<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Symfony\Component\HttpFoundation\Response;

class SuperadminAutoLogout
{
    /**
     * Handle an incoming request.
     *
     * @param  \Closure(\Illuminate\Http\Request): (\Symfony\Component\HttpFoundation\Response)  $next
     */
    public function handle(Request $request, Closure $next): Response
    {
      if (Auth::check()) {
        $user = Auth::user();

        // Assuming the user has only one role
        $roleName = $user->getRoleNames()->first();

        if (in_array($roleName, ['Supervisor', 'HR', 'Writer', 'superadmin'])) {
            Auth::logout();
            return redirect('/')->with('message', "$roleName has been automatically logged out.");
        }
    }

        return $next($request);
    }
}
